<?php

use Mbl\Membergroup\Chat;
use Mbl\Membergroup\ChatNotFoundError;
use Mbl\Membergroup\NoRightsManageInviteLinks;

add_action( 'admin_menu', function () {
//    add_menu_page(
//        'Закрытые TG группы',
//        'TG группы',
//        'manage_options',
//        'tg_groups',
//        'tg_groups_render_page',
//        'dashicons-format-chat',
//        10
//    );
} );

//function tg_groups_render_page() {
//
//}

add_action( 'wpm-levels_edit_form_fields', 'tg_groups_admin_view', 25 );
function tg_groups_admin_view( WP_Term $term ) {
	$term_id               = $term->term_id;
	$message               = get_term_meta( $term_id, 'tg_group_message', true ) ?: "Приглашение в закрытую группу:\n[membergroup_invitation]";
	$message_second        = get_term_meta( $term_id, 'tg_group_message_second', true ) ?: "Приглашение в закрытую группу:\n[membergroup_invitation]";
	$tg_group_image        = (int) get_term_meta( $term_id, 'tg_group_image', true );
	$tg_group_image_second = (int) get_term_meta( $term_id, 'tg_group_image_second', true );
	$on                    = get_term_meta( $term_id, 'tg_group_on', true );
	?>
    <tr class="form-field">
        <th scope="row">TG группа</th>
        <td>
	        <?php
            if(isset($_GET['debugger'])) {
                var_export(get_option( 'tg_admin_chats' ));
	        }
	        ?>
            <div class="wpm-tabs-wrap postbox wpm-ui-wrap" style="width: 95%;box-sizing: border-box;box-shadow: #0088CC 4px 4px 0 0;
                 border: 2px solid #32373c;background-color: #fff">
                <div class="wpm-inner-wrap">
                    <div style="margin-bottom: 10px;">
                        <label>
                            <input type="hidden" name="tg_groups[tg_group_on]" value="no">
                            <input type="checkbox" name="tg_groups[tg_group_on]"
								<?php checked( 'yes', $on ) ?>
                                   value="yes"> Выдается доступ в закрытую телеграм группу
                        </label>
                    </div>
                    <div<?= $on === 'yes' ? '' : ' style="display: none"' ?> id="tg_groups_fields">
                        <div style="margin-bottom: 20px;">
                            <label for="tg_group" style="display: inline-block;margin-bottom: 5px;">Телеграм
                                группа</label>
                            <div>
                                <select id="tg_group" name="tg_groups[tg_group_chat]">
                                    <option value="">Не выбрано</option>
									<?php foreach ( get_option( 'tg_admin_chats' ) ?: [] as $chat ): ?>
                                        <option <?php selected( $chat['chat_id'], get_term_meta( $term_id, 'tg_group_chat', true ) ) ?>
                                                value="<?= $chat['chat_id'] ?>"><?= $chat['title'] ?></option>
									<?php endforeach; ?>
                                </select>
                            </div>
                        </div>
                        <div style="margin-bottom: 10px;">
                            <label for="">
                                <input type="hidden" name="tg_groups[tg_group_exclude]" value="no">
                                <input type="checkbox" name="tg_groups[tg_group_exclude]"
									<?php checked( 'yes', get_term_meta( $term_id, 'tg_group_exclude', true ) ) ?>
                                       value="yes"> Исключить из группы по истечению срока действия доступа
                            </label>
                        </div>
                        <div style="margin-bottom: 10px;">
                            <label>
                                Задержка удаления от группы в днях&nbsp;
                                <input type="number"
                                       style="display: inline-block;width: 50px;"
                                       name="tg_groups[tg_group_offset]"
                                       value="<?= get_term_meta( $term_id, 'tg_group_offset', true ) ?: 0 ?>">
                            </label>
                        </div>
                        <div class="wpm-tabs wpm-inner-tabs-nav wpm-inner-tabs">
                            <ul class="wpm-inner-tabs-nav">
                                <li class="mbg-tabs"><a href="#mbg_invite">Первое сообщение</a></li>
                                <li class="mbg-tabs"><a href="#mbg_invite_second">Второе сообщение</a></li>
                            </ul>
                            <div class="tab" id="mbg_invite">
                                <div class="wpm-tab-content" style="max-width: unset">
                                    <div style="margin-bottom: 10px;">
                                        <div>
                                            <img style="<?= empty( $tg_group_image ) ? 'display:none;' : '' ?>height: 100px"
                                                 src="<?= wp_get_attachment_image_url( $tg_group_image ) ?>"
                                                 alt="" id="tg_groups_image">
                                        </div>
                                        <button id="mbg_media_button" type="button">Выбрать картинку</button>
                                        <input type="hidden" id="tg_group_image_inp" name="tg_groups[tg_group_image]"
                                               value="<?= $tg_group_image ?>">
                                    </div>
                                    <div style="margin-bottom: 10px;">
                                        <label for="mbg_message" style="display: inline-block;margin-bottom: 5px;">Текст
                                            приглашения</label>
                                        <div>
                                        <textarea name="tg_groups[tg_group_message]"
                                                  id="mbg_message" cols="30" rows="5"><?= $message ?></textarea>
                                        </div>
                                        <p>[membergroup_invitation] - ссылка на вступление</p>
                                    </div>
                                </div>
                            </div>
                            <div class="tab" id="mbg_invite_second">
                                <div class="wpm-tab-content" style="max-width: unset">
                                    <div style="margin-bottom: 10px;">
                                        <div>
                                            <img style="<?= empty( $tg_group_image_second ) ? 'display:none;' : '' ?>height: 100px"
                                                 src="<?= wp_get_attachment_image_url( $tg_group_image_second ) ?>"
                                                 alt="" id="tg_groups_image_second">
                                        </div>
                                        <button id="mbg_media_button_second" type="button">Выбрать картинку</button>
                                        <input type="hidden" id="tg_group_image_second_inp"
                                               name="tg_groups[tg_group_image_second]"
                                               value="<?= $tg_group_image_second ?>">
                                    </div>
                                    <div style="margin-bottom: 10px;">
                                        <label for="mbg_message_second"
                                               style="display: inline-block;margin-bottom: 5px;">Текст приглашения
                                            2</label>
                                        <div>
                                        <textarea name="tg_groups[tg_group_message_second]"
                                                  id="mbg_message_second" cols="30"
                                                  rows="5"><?= $message_second ?></textarea>
                                        </div>
                                        <p>[membergroup_invitation] - ссылка на вступление</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </td>
    </tr>
	<?php
}

add_action( 'admin_footer-term.php', function ( $a ) {
	?>
    <style>
        .wpm-inner-tabs-nav .ui-tabs-active.mbg-tabs > a {
            background-color: #0388CC;
        }
    </style>
    <script>
        (function ($) {
            $('[name="tg_groups[tg_group_on]"]').on('change', function () {
                if ($(this).is(':checked')) {
                    $('#tg_groups_fields').show()
                } else {
                    $('#tg_groups_fields').hide()
                }
            });

            function image_handler(id_inp, id_img, id_btn) {
                let frame = window.wp.media({
                    title: 'Выберите или загрузите изображение',
                    button: {
                        text: 'Выбрать изображение'
                    },
                    multiple: false
                });
                frame.on('select', function () {
                    const info = frame.state().get('selection').first().toJSON()
                    $(`#${id_inp}`).val(info.id)
                    $(`#${id_img}`).attr('src', info.url).show()
                })
                $(`#${id_btn}`).on('click', onclick)

                function onclick() {
                    frame.open()
                }
            }

            image_handler('tg_group_image_inp', 'tg_groups_image', 'mbg_media_button');
            image_handler('tg_group_image_second_inp', 'tg_groups_image_second', 'mbg_media_button_second');
        })(jQuery);
    </script>
	<?php
} );
add_action( 'edited_wpm-levels', function ( $term_id ) {
	if ( ! isset( $_POST['tg_groups'] ) ) {
		return;
	}
	if ( $_POST['tg_groups']['tg_group_on'] === 'yes' ) {
		if ( empty( $_POST['tg_groups']['tg_group_chat'] ) ) {
			return;
		}
		$inviteLink = get_term_meta( $term_id, 'tg_group_invite_link', true );
		if ( empty( $inviteLink ) ) {
			$chat = new Chat( $_POST['tg_groups']['tg_group_chat'] );
			try {
				$inviteLink = $chat->inviteLink( get_term( $term_id, 'wpm-levels' ) );
				update_term_meta( $term_id, 'tg_group_invite_link', $inviteLink );
			} catch ( ChatNotFoundError|NoRightsManageInviteLinks $error ) {
				return;
			}
		}
		foreach ( $_POST['tg_groups'] as $key => $value ) {
			update_term_meta( $term_id, $key, $value );
		}
	} else {
		foreach (
			[
				'tg_group_on',
				'tg_group_invite_link',
				'tg_group_chat',
				'tg_group_exclude',
				'tg_group_offset',
				'tg_group_image',
				'tg_group_message',
				'tg_group_image_second',
				'tg_group_message_second',
				'tg_group_message_second'
			] as $key
		) {
			delete_term_meta( $term_id, $key );
		}
	}
} );
