<?php
/*

Plugin Name: MEMBERGROUP
Plugin URI: https://memberlux.com
Description: МОДУЛЬ ДОБАВЛЕНИЯ В ЗАКРЫТЫЕ TELEGRAM ГРУППЫ
Version: 1.5
Author: Виктор Левчук
Author URI: https://t.me/leviktor

*/
namespace Mbl\Membergroup;

use Puc_v4_Factory;
use function get_plugin_data;
if (!defined('ABSPATH')) {
	exit;
}
if (!function_exists('get_plugin_data')) {
	require_once(ABSPATH . 'wp-admin/includes/plugin.php');
}
$plugin_data = get_plugin_data(__FILE__);
define('MBG_VERSION', $plugin_data['Version']);
define('MBG_PLUGIN_FILE', __FILE__);
define('MBG_PLUGIN_URI', plugin_dir_url(__FILE__));
define('MBG_PLUGIN_PATH', plugin_dir_path(__FILE__));
require_once __DIR__ . "/src/functions.php";
require_once __DIR__ . "/vendor/autoload.php";
require_once __DIR__ . "/event.php";
$MembergroupPlugin = new Plugin();
$MembergroupCore = new Core($MembergroupPlugin);
$MembergroupCore->run();
//Updater
require __DIR__ . '/plugin-update-checker/plugin-update-checker.php';
$myUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
    'https://github.com/MEMBERLUX/membergroup/',
    __FILE__,
    'membergroup'
);
$myUpdateChecker->setAuthentication('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');
