<?php

namespace Mbl\Membergroup;


class Plugin
{
    public function activate(): void
    {
        $date = new \DateTime(date('Y-m-d 19:17:00'), wp_timezone());
        wp_clear_scheduled_hook('mbg_schedule_event');
        wp_schedule_event($date->getTimestamp(), 'daily', 'mbg_schedule_event');
    }

    public function deactivate(): void
    {
        wp_clear_scheduled_hook('mbg_schedule_event');
    }

    public function path($relative): string
    {
        return MBG_PLUGIN_PATH . $relative;
    }
}